//wcomtest
#define ESC 27
#define STONE_BLACK 1
#include <windows.h>
#include <stdio.h>
#include <iostream.h>
#include <conio.h>

#include "cgfcomlt.h"

int port_num;
int my_color;
volatile UINT movecount;
int teban;
int ret;
int x,y;
BOOL endgameflag;

VOID main(VOID)
{
	HINSTANCE hLib;

	cout << "CGF go-communication test" << endl;

	hLib = LoadLibrary("cgfcom");
	if(hLib==NULL) {
		cout << "not able to use DLL." << endl;
		return;
	}
	initcom = (BOOL(*)(int))GetProcAddress(hLib,"initcom");
	if(initcom <= 0) {
		FreeLibrary(hLib);
		return;
	}
	closecom = (BOOL(*)(VOID))GetProcAddress(hLib,"closecom");
	if(closecom <= 0) {
		FreeLibrary(hLib);
		return;
	}

	sendxy = (BOOL(*)(int, int))GetProcAddress(hLib,"sendxy");
	if(sendxy <= 0) {
		FreeLibrary(hLib);
		return;
	}
	
	receivexy = (BOOL(*)(int *, int *))GetProcAddress(hLib,"receivexy");
	if(receivexy <= 0) {
		FreeLibrary(hLib);
		return;
	}
	newgame = (BOOL(*)(int))GetProcAddress(hLib,"newgame");
	if(newgame <= 0) {
		FreeLibrary(hLib);
		return;
	}

	cout << "port_num:? ";
	cin >> port_num;
	if(!initcom(port_num)) {
		cout << "initcom error" << endl;
		return;
	}
	cout << "color:? "; cin >> my_color;
	cout << "my_color " << my_color << endl;

	if(!newgame(my_color)) {
		cout << "newgame timeout" << endl;
		closecom();
		FreeLibrary(hLib);
		return;
	}
	cout << "Newgame starts" << endl;
	movecount = 0;
	endgameflag = FALSE;
	while (TRUE) {
	movecount++;
	teban = ((movecount+1) & 1) + 1;
	cout << "step:" << movecount << endl;
	if(teban == my_color) {
		cout << " x= "; cin >> x;
		cout << " y= "; cin >> y;
		if(!sendxy(x,y)) {
			cout << "sendxy timeout" << endl;
			closecom();
			FreeLibrary(hLib);
			return;
		}
	}
	else {
		do {
			ret = receivexy(&x,&y);
			if(_kbhit()) if(getch()==ESC) {
				endgameflag = TRUE;
				break;
			}
		} while (!ret);
		if(endgameflag) break;
		cout << " x,y = " << x << " " << y << endl;}
	}
	closecom();
	FreeLibrary(hLib);
	cout << "end of game" << endl;
}